package es.claro.persistence;

import javax.persistence.EntityManager;

/**
 * 
 * @author puche
 */
public class LazyCloseEntityManager extends EntityManagerProxy {

   private LazyCloseListener listener;

   public LazyCloseEntityManager(final EntityManager delegate) {

      super(delegate);
   }

   public void setLazyCloseListener(final LazyCloseListener listener) {

      this.listener = listener;
   }

   public LazyCloseListener getLazyCloseListener() {

      return listener;
   }

   @Override
   public void close() {
   }

   protected void lazyClose() {

      super.close();
      if (listener != null) {
         listener.lazilyClosed();
      }
   }

   // TODO HACK!!! create new class HibernateLazyCloseEntityManager and make the
   // factories accept some parameters
}